package com.company.buginheritancepertable.screen.parent

import io.jmix.ui.screen.*
import com.company.buginheritancepertable.entity.Parent
import io.jmix.core.DataManager
import io.jmix.ui.model.CollectionContainer
import io.jmix.ui.model.CollectionLoader
import io.jmix.ui.screen.Target
import org.springframework.beans.factory.annotation.Autowired

@UiController("Parent.browse")
@UiDescriptor("parent-browse.xml")
@LookupComponent("parentsTable")
class ParentBrowse : StandardLookup<Parent>() {
    @Autowired
    private lateinit var dataManager: DataManager
    @Autowired
    private lateinit var parentsDc: CollectionContainer<Parent>
    @Autowired
    private lateinit var parentsDl: CollectionLoader<Parent>

    @Subscribe(id = "parentsDc", target = Target.DATA_CONTAINER)
    private fun onParentsDcCollectionChange(event: CollectionContainer.CollectionChangeEvent<Parent>) {
        // we can see that childReference is not null in DB.
        println("in database: " + dataManager.load(Parent::class.java).all().list().first().childReference?.getInstanceName())
        // but the screen fails to load childReference despite that it's in the fetch plan
        println("in dataContainer: " + parentsDc.items.first().childReference?.getInstanceName())
    }


}